// linux.cpp

#include "jcpplisp.h"

CELL *cfunction::char_to_code(CELL *p,SYMVAL *loc,long locn,long lock)
{
    CELL *q,*r,*s;
    AINT *i;

    if (p->attr != 'l') goto serror;
    s = p->car;
    IncCellStack(NULL);
    IncCellStack(p);
    q = eval(s,loc,locn,lock);
    PopCellStack();
    if (q == NULL) return NULL;
    if (q->attr != 'm') goto serror;
    i = (AINT *)getInt(((unsigned long)(q->car)) & 0xff);
    r = getCell();
    r->attr = 'i';
    r->car = (CELL *)i;
    r->cdr = NULL;
    return r;

 serror:
    printf("G[: CHAR-CODE̎gԈĂ܂B\n");
    errorlisp(loc,locn);
    return NULL;
}

CELL *cfunction::code_to_char(CELL *p,SYMVAL *loc,long locn,long lock)
{
    CELL *q,*r,*s;
    long c;

    if (p->attr != 'l') goto serror;
    s = p->car;
    IncCellStack(NULL);
    IncCellStack(p);
    q = eval(s,loc,locn,lock);
    PopCellStack();
    if (q == NULL) return NULL;
    if (q->attr != 'i') goto serror;
    c = (((AINT *)(q->car))->f);
    if (c < 0) goto serror;
    c &= 0xff;
    r = getCell();
    r->attr = 'm';
    r->car = (CELL *)c;
    r->cdr = NULL;
    return r;

 serror:
    printf("G[: CODE-CHAR̎gԈĂ܂B\n");
    errorlisp(loc,locn);
    return NULL;
}

// end of file

